use std::convert::Infallible;
use axum::{
    extract::FromRequestParts,
    http::{request::Parts, HeaderMap},
};
use cookie::{Cookie, CookieJar as CookieCookieJar};

/// This is required because "Cookie" his a forbidden header for some fucking reason.
/// Stupidest thing I've ever encountered in JavaScript, absolute fucking insanity.
///
/// Anyway, most of this shit is just from the original source for axum_extra::extract::CookieJar,
/// just edited to use X-Cookie instead.
///
/// Stuff from axum_extra will have links to the original provided.
pub struct CookieJar {
    jar: CookieCookieJar,
}

/// <https://docs.rs/axum-extra/latest/src/axum_extra/extract/cookie/mod.rs.html#92-101>
impl<S> FromRequestParts<S> for CookieJar
where
    S: Send + Sync,
{
    type Rejection = Infallible;

    async fn from_request_parts(parts: &mut Parts, _state: &S) -> Result<Self, Self::Rejection> {
        Ok(Self::from_headers(&parts.headers))
    }
}

fn cookies_from_request(
    header: String,
    headers: &HeaderMap,
) -> impl Iterator<Item = Cookie<'static>> + '_ {
    headers
        .get_all(header)
        .into_iter()
        .filter_map(|value| value.to_str().ok())
        .flat_map(|value| value.split(';'))
        .filter_map(|cookie| Cookie::parse_encoded(cookie.to_owned()).ok())
}

impl CookieJar {
    /// <https://docs.rs/axum-extra/latest/axum_extra/extract/cookie/struct.CookieJar.html#method.from_headers>
    ///
    /// Modified only to prefer "X-Cookie" header.
    pub fn from_headers(headers: &HeaderMap) -> Self {
        let mut jar = CookieCookieJar::new();

        for cookie in cookies_from_request(
            if headers.contains_key("X-Cookie") {
                "X-Cookie".to_string()
            } else {
                "Cookie".to_string()
            },
            headers,
        ) {
            jar.add_original(cookie.clone());
        }

        Self { jar }
    }

    /// <https://docs.rs/axum-extra/latest/axum_extra/extract/cookie/struct.CookieJar.html#method.get>
    pub fn get(&self, name: &str) -> Option<&Cookie<'static>> {
        self.jar.get(name)
    }
}
