(text "{% extends \"root.html\" %} {% block head %}")
(title
    (text "{{ community.context.display_name }} - {{ config.name }}"))

(meta
    ("name" "og:title")
    ("content" "{{ community.title }}"))

(meta
    ("name" "description")
    ("content" "View the \\\"{{ community.title }}\\\" community on {{ config.name }}!"))

(meta
    ("name" "og:description")
    ("content" "View the \\\"{{ community.title }}\\\" community on {{ config.name }}!"))

(meta
    ("property" "og:type")
    ("content" "profile"))

(meta
    ("property" "profile:username")
    ("content" "{{ community.title }}"))

(meta
    ("name" "og:image")
    ("content" "{{ config.host|safe }}/api/v1/communities/{{ community.id }}/avatar"))

(meta
    ("name" "twitter:image")
    ("content" "{{ config.host|safe }}/api/v1/communities/{{ community.id }}/avatar"))

(meta
    ("name" "twitter:card")
    ("content" "summary"))

(meta
    ("name" "twitter:title")
    ("content" "{{ community.title }}"))

(meta
    ("name" "twitter:description")
    ("content" "View the \\\"{{ community.title }}\\\" community on {{ config.name }}!"))

(text "{% endblock %} {% block body %} {{ macros::nav() }}")
(article
    (div
        ("class" "content_container flex flex-col gap-4")
        (text "{{ components::community_banner(id=community.id, community=community) }}")
        (div
            ("class" "w-full flex gap-4 flex-collapse")
            (div
                ("class" "lhs flex flex-col gap-2 sm:w-full")
                ("style" "width: 22rem; min-width: 22rem")
                (div
                    ("class" "card-nest w-full")
                    (div
                        ("class" "card flex gap-2")
                        ("id" "community_avatar_and_name")
                        (text "{{ components::community_avatar(id=community.id, community=community, size=\"72px\") }}")
                        (div
                            ("class" "flex flex-col")
                            (div
                                ("class" "flex gap-2 items-center")
                                (h3
                                    ("id" "title")
                                    ("class" "title name shorter flex gap-2")
                                    (text "{% if community.context.display_name -%} {{ community.context.display_name }} {% else %} {{ community.title }} {%- endif %}  {% if community.context.is_nsfw -%}")
                                    (span
                                        ("title" "NSFW community")
                                        ("class" "flex items-center")
                                        ("style" "color: var(--color-primary)")
                                        (text "{{ icon \"square-asterisk\" }}"))
                                    (text "{%- endif %}")))
                            (span
                                ("class" "fade")
                                (text "{{ community.title }}"))))
                    (text "{{ components::community_actions(community=community) }}"))
                (text "{{ components::community_info(community=community) }}"))
            (div
                ("class" "rhs w-full")
                (text "{% if can_read -%} {% block content %}{% endblock %} {% else %}")
                (div
                    ("class" "card-nest")
                    (div
                        ("class" "card small flex items-center gap-2")
                        (text "{{ icon \"frown\" }}")
                        (b
                            (text "{{ text \"communities:label.not_allowed_to_read\" }}")))
                    (div
                        ("class" "card")
                        (span
                            (text "{{ text \"communities:label.might_need_to_join\" }}"))))
                (text "{%- endif %}")))))

(text "{% if community.is_forge and not allow_for_forges %}")
(script
    (text "window.location.pathname = window.location.pathname.replace(\"/community\", \"/forge\")"))
(text "{% endif %}")
(text "{% endblock %}")
