(text "{% extends \"root.html\" %} {% block head %}")
(title
    (text "Create post - {{ config.name }}"))

(text "{% endblock %} {% block body %} {{ macros::nav() }}")
(main
    ("class" "flex flex-col gap-2")
    (text "{% if drafts|length > 0 -%}")
    (div
        ("class" "pillmenu")
        (a
            ("href" "#/create")
            ("data-tab-button" "create")
            ("class" "active")
            (text "{{ icon \"plus\" }}")
            (span
                (text "{{ text \"general:action.post\" }}")))
        (a
            ("href" "#/drafts")
            ("data-tab-button" "drafts")
            (text "{{ icon \"notepad-text-dashed\" }}")
            (span
                (text "{{ text \"communities:label.drafts\" }}"))))
    (text "{%- endif %}")
    (div
        ("class" "card-nest")
        ("data-tab" "create")
        (div
            ("class" "card small flex items-center justify-between gap-2")
            (span
                ("class" "flex items-center gap-2")
                (text "{{ icon \"pen\" }}")
                (span
                    (text "{{ text \"communities:label.create_post\" }}")))
            (button
                ("onclick" "cancel_create_post()")
                ("class" "lowered small red")
                (text "{{ icon \"x\" }}")
                (span
                    (text "{{ text \"dialog:action.cancel\" }}"))))
        (div
            ("class" "card lowered flex flex-col gap-2")
            (text "{% if draft -%}")
            (div
                ("class" "card secondary w-full flex items-center justify-between gap-2 small")
                (a
                    ("class" "flex items-center gap-2 flush")
                    ("href" "#/drafts")
                    (text "{{ icon \"notepad-text-dashed\" }}")
                    (span
                        ("class" "date")
                        (text "{{ draft.created }}")))
                (div
                    ("class" "flex gap-2")
                    (a
                        ("href" "?")
                        ("class" "button lowered small")
                        (text "{{ icon \"x\" }}")
                        (span
                            (text "{{ text \"dialog:action.cancel\" }}")))
                    (button
                        ("class" "button lowered red small")
                        ("onclick" "remove_draft('{{ draft.id }}')")
                        (text "{{ icon \"trash\" }}")
                        (span
                            (text "{{ text \"general:action.delete\" }}")))))
            (text "{%- endif %} {% if quoting -%}")
            (div
                ("class" "card secondary w-full flex items-center justify-between gap-2 small")
                (a
                    ("class" "flex items-center gap-2 flush")
                    ("href" "/post/{{ quoting[1].id }}")
                    (text "{{ icon \"quote\" }}")
                    (span
                        (text "{{ quoting[0].username }}'s post")))
                (a
                    ("href" "?")
                    ("class" "button lowered small")
                    (text "{{ icon \"x\" }}")
                    (span
                        (text "{{ text \"dialog:action.cancel\" }}"))))
            (text "{%- endif %}")
            (div
                ("class" "card-nest")
                (div
                    ("class" "card small flex flex-row gap-2 items-center")
                    (text "{{ components::avatar(username=user.id, size=\"32px\", selector_type=\"id\") }}")
                    (select
                        ("id" "community_to_post_to")
                        ("onchange" "update_community_avatar(event); check_community_supports_title(event)")
                        (option
                            ("value" "{{ config.town_square }}")
                            ("selected" "{% if not selected_community -%}true{% else %}false{%- endif %}")
                            (text "{{ text \"auth:link.my_profile\" }}"))
                        (text "{% for community in communities %}")
                        (option
                            ("value" "{{ community.id }}")
                            ("selected" "{% if selected_community == community.id -%}true{% else %}false{%- endif %}")
                            (text "{% if community.context.display_name -%} {{ community.context.display_name }} {% else %} {{ community.title }} {%- endif %}"))
                        (text "{% endfor %}")
                        (text "{% for stack in stacks %}")
                        (option
                            ("value" "{{ stack.id }}")
                            ("selected" "{% if selected_stack == stack.id -%}true{% else %}false{%- endif %}")
                            ("is_stack" "true")
                            (text "{{ stack.name }} (circle)"))
                        (text "{% endfor %}")))
                (form
                    ("class" "card flex flex-col gap-2")
                    ("id" "create_form")
                    ("onsubmit" "create_post_from_form(event)")
                    (div
                        ("class" "flex flex-col gap-1 hidden")
                        ("id" "title_field")
                        (label
                            ("for" "content")
                            (text "{{ text \"communities:label.title\" }}"))
                        (input
                            ("type" "text")
                            ("name" "title")
                            ("id" "title")
                            ("placeholder" "title")
                            ("minlength" "2")
                            ("maxlength" "128")))
                    (div
                        ("class" "flex flex-col gap-1")
                        (label
                            ("for" "content")
                            (text "{{ text \"communities:label.content\" }}"))
                        (textarea
                            ("type" "text")
                            ("name" "content")
                            ("id" "content")
                            ("placeholder" "content")
                            ("minlength" "2")
                            ("maxlength" "4096")
                            (text "{% if draft -%}{{ draft.content }}{%- endif %}")))
                    (div
                        ("id" "files_list")
                        ("class" "flex gap-2 flex-wrap"))
                    (div
                        ("class" "flex justify-between flex-collapse gap-2")
                        (text "{{ components::create_post_options() }}")
                        (div
                            ("class" "flex gap-2")
                            (text "{% if not quoting -%} {% if draft -%}")
                            (button
                                ("class" "secondary small square")
                                ("title" "Save as Draft")
                                ("onclick" "update_draft('{{ draft.id }}')")
                                ("type" "button")
                                (text "{{ icon \"notepad-text-dashed\" }}"))
                            (text "{% else %}")
                            (button
                                ("class" "secondary small square")
                                ("title" "Save as Draft")
                                ("onclick" "create_draft()")
                                ("type" "button")
                                (text "{{ icon \"notepad-text-dashed\" }}"))
                            (text "{%- endif %} {%- endif %}")
                            (button
                                ("class" "primary")
                                (text "{{ text \"communities:action.create\" }}"))))))
            (text "{% if not quoting -%}")
            (script
                (text "async function create_post_from_form(e) {
                    e.preventDefault();
                    await trigger(\"atto::debounce\", [\"posts::create\"]);

                    e.target
                        .querySelector(\"button.primary\")
                        .classList.add(\"hidden\");

                    // poll
                    const poll_data = get_poll_data();

                    if (!poll_data[0]) {
                        e.target
                            .querySelector(\"button.primary\")
                            .classList.remove(\"hidden\");

                        return alert(poll_data[1]);
                    }

                    // create body
                    const body = new FormData();

                    if (e.target.file_picker) {
                        for (const file of e.target.file_picker.files) {
                            body.append(file.name, file);
                        }
                    }

                    const is_selected_stack = document.getElementById(
                        \"community_to_post_to\",
                    ).selectedOptions[0].getAttribute(\"is_stack\") === \"true\";
                    const selected_community = document.getElementById(
                        \"community_to_post_to\",
                    ).selectedOptions[0].value;

                    body.append(
                        \"body\",
                        JSON.stringify({
                            content: e.target.content.value,
                            community: !is_selected_stack ? selected_community : \"0\",
                            stack: is_selected_stack ? selected_community : \"0\",
                            poll: poll_data[1],
                            title: e.target.title.value,
                        }),
                    );

                    // ...
                    fetch(\"/api/v1/posts\", {
                        method: \"POST\",
                        body,
                    })
                        .then((res) => res.json())
                        .then(async (res) => {
                            trigger(\"atto::toast\", [
                                res.ok ? \"success\" : \"error\",
                                res.message,
                            ]);

                            if (res.ok) {
                                // update settings
                                await update_settings_maybe(res.payload);

                                // remove draft
                                // {% if draft -%}
                                if (\"{{ draft.id }}\") {
                                    fetch(\"/api/v1/drafts/{{ draft.id }}\", {
                                        method: \"DELETE\",
                                    })
                                        .then((res) => res.json())
                                        .then((res) => {
                                            trigger(\"atto::toast\", [
                                                res.ok ? \"success\" : \"error\",
                                                res.message,
                                            ]);
                                        });
                                }
                                // {%- endif %}

                                // ...
                                setTimeout(() => {
                                    window.location.href = `/post/${res.payload}`;
                                }, 100);
                            } else {
                                e.target
                                    .querySelector(\"button.primary\")
                                    .classList.remove(\"hidden\");
                            }
                        });
                }

                async function create_draft() {
                    const e = {
                        target: document.getElementById(\"create_form\"),
                    };

                    await trigger(\"atto::debounce\", [\"posts::create\"]);

                    e.target
                        .querySelector(\"button.primary\")
                        .classList.add(\"hidden\");

                    fetch(\"/api/v1/drafts\", {
                        method: \"POST\",
                        headers: {
                            \"Content-Type\": \"application/json\",
                        },
                        body: JSON.stringify({
                            content: e.target.content.value,
                        }),
                    })
                        .then((res) => res.json())
                        .then((res) => {
                            trigger(\"atto::toast\", [
                                res.ok ? \"success\" : \"error\",
                                res.message,
                            ]);

                            if (res.ok) {
                                setTimeout(() => {
                                    window.location.href = `?from_draft=${res.payload}`;
                                }, 100);
                            } else {
                                e.target
                                    .querySelector(\"button.primary\")
                                    .classList.remove(\"hidden\");
                            }
                        });
                }

                async function update_draft(id) {
                    const e = {
                        target: document.getElementById(\"create_form\"),
                    };

                    await trigger(\"atto::debounce\", [\"posts::create\"]);

                    e.target
                        .querySelector(\"button.primary\")
                        .classList.add(\"hidden\");

                    fetch(`/api/v1/drafts/${id}`, {
                        method: \"POST\",
                        headers: {
                            \"Content-Type\": \"application/json\",
                        },
                        body: JSON.stringify({
                            content: e.target.content.value,
                        }),
                    })
                        .then((res) => res.json())
                        .then((res) => {
                            trigger(\"atto::toast\", [
                                res.ok ? \"success\" : \"error\",
                                res.message,
                            ]);

                            if (!res.ok) {
                                e.target
                                    .querySelector(\"button.primary\")
                                    .classList.remove(\"hidden\");
                            }
                        });
                }"))
            (text "{% else %}")
            (script
                (text "async function create_post_from_form(e) {
                    e.preventDefault();
                    const id = await trigger(\"me::repost\", [
                        \"{{ quoting[1].id }}\",
                        e.target.content.value,
                        document.getElementById(\"community_to_post_to\")
                            .selectedOptions[0].value,
                        false,
                        document.getElementById(\"community_to_post_to\")
                            .selectedOptions[0].getAttribute(\"is_stack\") === \"true\",
                    ]);

                    // update settings
                    await update_settings_maybe(id);

                    // redirect
                    setTimeout(() => {
                        window.location.href = `/post/${id}`;
                    }, 100);
                }"))
            (text "{%- endif %}")))
    (text "{% if drafts|length > 0 -%}")
    (div
        ("class" "card-nest lowered hidden")
        ("data-tab" "drafts")
        (div
            ("class" "card small flex items-center gap-2")
            (text "{{ icon \"notepad-text-dashed\" }}")
            (span
                (text "{{ text \"communities:label.drafts\" }}")))
        (div
            ("class" "card flex flex-col gap-2")
            (text "{{ components::supporter_ad(body=\"Become a supporter to save infinite post drafts!\") }} {% for draft in drafts %}")
            (div
                ("class" "card-nest")
                (div
                    ("class" "card small flex flex-col gap-2")
                    (span
                        ("class" "no_p_margin")
                        (text "{{ draft.content|markdown|safe }}"))
                    (span
                        ("class" "fade date")
                        (text "{{ draft.created }}")))
                (div
                    ("class" "card flex gap-2 secondary")
                    (a
                        ("href" "?from_draft={{ draft.id }}")
                        ("class" "button small")
                        (text "{{ icon \"pen-line\" }}")
                        (span
                            (text "{{ text \"communities:label.load\" }}")))
                    (button
                        ("class" "button lowered red small")
                        ("onclick" "remove_draft('{{ draft.id }}')")
                        (text "{{ icon \"trash\" }}")
                        (span
                            (text "{{ text \"general:action.delete\" }}")))))
            (text "{% endfor %}")))
    (script
        (text "async function remove_draft(id) {
            if (
                !(await trigger(\"atto::confirm\", [
                    \"Are you sure you want to do this?\",
                ]))
            ) {
                return;
            }

            fetch(`/api/v1/drafts/${id}`, {
                method: \"DELETE\",
            })
                .then((res) => res.json())
                .then((res) => {
                    trigger(\"atto::toast\", [
                        res.ok ? \"success\" : \"error\",
                        res.message,
                    ]);
                });
        }"))
    (text "{%- endif %}"))

(script
    (text "(() => {const town_square = \"{{ config.town_square }}\";
    const user_id = \"{{ user.id }}\";

    window.update_community_avatar = (e) => {
        const element = e.target.parentElement.querySelector(\".avatar\");
        const is_stack = e.target.selectedOptions[0].getAttribute(\"is_stack\") === \"true\";
        const id = e.target.selectedOptions[0].value;

        element.setAttribute(\"title\", id);
        element.setAttribute(\"alt\", `${id}'s avatar`);

        if (id === town_square || is_stack) {
            element.src = `/api/v1/auth/user/${user_id}/avatar?selector_type=id`;
        } else {
            element.src = `/api/v1/communities/${id}/avatar`;
        }
    }

    window.check_community_supports_title = async (e) => {
        const element = document.getElementById(\"title_field\");
        const is_stack = e.target.selectedOptions[0].getAttribute(\"is_stack\") === \"true\";
        const id = e.target.selectedOptions[0].value;

        if (is_stack) {
            element.classList.add(\"hidden\");
            return;
        }

        fetch(`/api/v1/communities/${id}/supports_titles`)
            .then((res) => res.json())
            .then((res) => {
                if (res.message === \"yes\") {
                    element.classList.remove(\"hidden\");
                } else {
                    element.classList.add(\"hidden\");
                }
            });
    }

    setTimeout(() => {
        update_community_avatar({
            target: document.getElementById(\"community_to_post_to\"),
        });

        check_community_supports_title({
            target: document.getElementById(\"community_to_post_to\"),
        });
    }, 150);

    window.cancel_create_post = async () => {
        if (
            !(await trigger(\"atto::confirm\", [
                \"Are you sure you would like to do this? Your post content will be lost.\",
            ]))
        ) {
            return;
        }

        window.history.back();
    }})();"))

(text "{% endblock %}")
