; this is essentially the same as `communities/base.lisp`, but it has some minor
; changes to be more github-like instead of retrospring-like
(text "{% extends \"root.html\" %} {% block head %}")
(title
    (text "{{ community.context.display_name }} - {{ config.name }}"))

(meta
    ("name" "og:title")
    ("content" "{{ community.title }}"))

(meta
    ("name" "description")
    ("content" "View the \\\"{{ community.title }}\\\" community on {{ config.name }}!"))

(meta
    ("name" "og:description")
    ("content" "View the \\\"{{ community.title }}\\\" community on {{ config.name }}!"))

(meta
    ("property" "og:type")
    ("content" "profile"))

(meta
    ("property" "profile:username")
    ("content" "{{ community.title }}"))

(meta
    ("name" "og:image")
    ("content" "{{ config.host|safe }}/api/v1/communities/{{ community.id }}/avatar"))

(meta
    ("name" "twitter:image")
    ("content" "{{ config.host|safe }}/api/v1/communities/{{ community.id }}/avatar"))

(meta
    ("name" "twitter:card")
    ("content" "summary"))

(meta
    ("name" "twitter:title")
    ("content" "{{ community.title }}"))

(meta
    ("name" "twitter:description")
    ("content" "View the \\\"{{ community.title }}\\\" community on {{ config.name }}!"))

(text "{% endblock %} {% block body %} {{ macros::nav() }}")
(main
    (div
        ("class" "content_container flex flex-col gap-4")
        (div
            ("class" "card-nest")
            (div
                ("class" "card flex gap-2")
                ("id" "community_avatar_and_name")
                (text "{{ components::community_avatar(id=community.id, community=community, size=\"72px\") }}")
                (div
                    ("class" "flex flex-col")
                    (div
                        ("class" "flex gap-2 items-center")
                        (h3
                            ("id" "title")
                            ("class" "title name shorter flex gap-2")
                            (text "{% if community.context.display_name -%} {{ community.context.display_name }} {% else %} {{ community.title }} {%- endif %}  {% if community.context.is_nsfw -%}")
                            (span
                                ("title" "NSFW community")
                                ("class" "flex items-center")
                                ("style" "color: var(--color-primary)")
                                (text "{{ icon \"square-asterisk\" }}"))
                            (text "{%- endif %}")))
                    (span
                        ("class" "fade")
                        (text "{{ community.title }}"))))

            (text "{{ components::community_actions(community=community) }}"))

        (text "{% block content %}{% endblock %}")))

(text "{% if not community.is_forge %}")
(script
    (text "window.location.pathname = window.location.pathname.replace(\"/forge\", \"/community\")"))
(text "{% endif %}")
(text "{% endblock %}")
