(text "{% extends \"root.html\" %} {% block head %}")
(title
    (text "Seller settings - {{ config.name }}"))
(text "{% endblock %} {% block body %} {{ macros::nav() }}")
(main
    ("class" "flex flex-col gap-2")

    ; nav
    (div
        ("class" "mobile_nav mobile")
        ; primary nav
        (div
            ("class" "dropdown")
            ("style" "width: max-content")
            (button
                ("class" "raised small")
                ("onclick" "trigger('atto::hooks::dropdown', [event])")
                ("exclude" "dropdown")
                (icon (text "sliders-horizontal"))
                (span ("class" "current_tab_text") (text "account")))
            (div
                ("class" "inner left")
                (text "{{ macros::seller_settings_nav_options() }}"))))

    ; nav desktop
    (div
        ("class" "desktop pillmenu")
        (text "{{ macros::seller_settings_nav_options() }}"))

    ; ...
    (div
        ("class" "card w-full lowered flex flex-col gap-2")
        ("data-tab" "account")
        (div
            ("class" "card-nest w-full")
            (div
                ("class" "card small flex items-center gap-2")
                (div
                    ("class" "notification")
                    ("style" "width: 46px")
                    (icon (text "stripe")))

                (b (str (text "marketplace:label.status"))))

            (div
                ("class" "card")
                (text "{% if user.seller_data.account_id -%}")
                (text "{% if user.seller_data.completed_onboarding -%}")
                ; completed onboarding + has stripe account linked
                (button
                    ("onclick" "trigger('seller::login')")
                    (icon (text "arrow-right"))
                    (str (text "marketplace:action.open_seller_dashboard")))
                (text "{% else %}")
                ; not completed onboarding
                (p (text "You've not finished setting up your Stripe account."))
                (p (text "Please complete onboarding to accept payments."))

                (button
                    ("onclick" "trigger('seller::onboarding')")
                    (icon (text "arrow-right"))
                    (str (text "marketplace:action.finsh_setting_up_account")))
                (text "{%- endif %}")
                (text "{% else %}")
                ; doesn't have a stripe account linked
                (button
                    ("onclick" "trigger('seller::register')")
                    (icon (text "arrow-right"))
                    (str (text "marketplace:action.get_started")))
                (text "{%- endif %}"))))

    (div
        ("class" "card w-full lowered hidden flex flex-col gap-2")
        ("data-tab" "products")
        (div
            ("class" "card w-full flex flex-wrap gap-2")
            )))

(text "{% endblock %}")
