(text "{% extends \"root.html\" %} {% block head %}")
(title
    (text "Notifications - {{ config.name }}"))

(text "{% endblock %} {% block body %} {{ macros::nav(selected=\"notifications\") }}")
(main
    ("class" "flex flex-col gap-2")

    ; viewing other user's notifications warning
    (text "{% if profile.id != user.id -%}")
    (div
        ("class" "card w-full red flex gap-2 items-center")
        (text "{{ icon \"skull\" }}")
        (b
            (text "Viewing other user's notifications! Please be careful.")))
    (text "{%- endif %}")

    ; ...
    (div
        ("class" "card-nest")
        (div
            ("class" "card small flex items-center justify-between gap-2")
            (span
                ("class" "flex items-center gap-2")
                (text "{{ icon \"bell\" }}")
                (span
                    (text "{{ text \"notifs:label.notifications\" }}")))
            (div
                ("class" "flex gap-2")
                (button
                    ("onclick" "trigger('me::clear_notifs')")
                    ("class" "small red lowered")
                    (text "{{ icon \"bomb\" }}")
                    (span
                        (text "{{ text \"notifs:action.clear\" }}")))
                (div
                    ("class" "dropdown")
                    (button
                        ("class" "small lowered")
                        ("onclick" "trigger('atto::hooks::dropdown', [event])")
                        ("exclude" "dropdown")
                        (text "{{ icon \"ellipsis\" }}"))
                    (div
                        ("class" "inner")
                        (button
                            ("onclick" "mark_all_as_read(true)")
                            (text "{{ icon \"bookmark-check\" }}")
                            (span
                                (text "{{ text \"notifs:label.mark_all_as_read\" }}")))
                        (button
                            ("onclick" "mark_all_as_read(false)")
                            (text "{{ icon \"bookmark-x\" }}")
                            (span
                                (text "{{ text \"notifs:label.mark_all_as_unread\" }}")))))))
        (div
            ("class" "card lowered flex flex-col gap-4")
            (text "{% for notification in notifications %} {{ components::notification(notification=notification) }} {% endfor %}")))

    (text "{{ components::pagination(page=page, items=notifications|length, key=\"&id=\", value=profile.id) }}"))

(script
    (text "async function mark_all_as_read(read) {
        if (
            !(await trigger(\"atto::confirm\", [
                \"Are you sure you want to do this?\",
            ]))
        ) {
            return;
        }

        fetch(\"/api/v1/notifications/all/read_status\", {
            method: \"POST\",
            headers: {
                \"Content-Type\": \"application/json\",
            },
            body: JSON.stringify({
                read,
            }),
        })
            .then((res) => res.json())
            .then((res) => {
                trigger(\"atto::toast\", [
                    res.ok ? \"success\" : \"error\",
                    res.message,
                ]);
            });
    }"))

(text "{% endblock %}")
