(text "{% extends \"root.html\" %} {% block head %}")
(title
    (text "Reports - {{ config.name }}"))

(text "{% endblock %} {% block body %} {{ macros::nav() }}")
(main
    ("class" "flex flex-col gap-2")
    (div
        ("class" "card-nest w-full")
        (div
            ("class" "card small flex items-center gap-2")
            (text "{{ icon \"flag\" }}")
            (span
                (text "{{ text \"general:link.reports\" }}")))
        (div
            ("class" "card flex flex-col gap-2")
            (text "{% for item in items %}")
            (div
                ("class" "card-nest")
                (a
                    ("class" "card small flex items-center gap-2 flush")
                    ("href" "/api/v1/auth/user/find/{{ item.owner }}")
                    (text "{{ components::avatar(username=item.owner, selector_type=\"id\") }}")
                    (span
                        (text "{{ item.owner }}"))
                    (span
                        ("class" "fade date")
                        (text "{{ item.created }}")))
                (div
                    ("class" "card secondary flex flex-col gap-2")
                    (span
                        ("class" "no_p_margin")
                        (text "{{ item.content|markdown|safe }}"))
                    (div
                        ("class" "card w-full flex flex-wrap gap-2")
                        (button
                            ("onclick" "open_reported_content('{{ item.asset }}', '{{ item.asset_type }}')")
                            (text "{{ icon \"external-link\" }}")
                            (span
                                (text "{{ text \"mod_panel:label.open_reported_content\" }}")))
                        (button
                            ("onclick" "remove_report('{{ item.id }}')")
                            ("class" "red lowered")
                            (text "{{ icon \"trash\" }}")
                            (span
                                (text "{{ text \"general:action.delete\" }}"))))))
            (text "{% endfor %}")
            (text "{{ components::pagination(page=page, items=items|length) }}"))))

(script
    (text "function open_reported_content(asset, asset_type) {
        if (asset_type === \"Post\") {
            window.open(`/post/${asset}`);
        } else if (asset_type === \"Community\") {
            window.open(`/community/${asset}`);
        } else if (asset_type === \"User\") {
            window.open(`/api/v1/auth/user/find/${asset}`);
        }
    }

    function remove_report(id) {
        fetch(`/api/v1/reports/${id}`, {
            method: \"DELETE\",
        })
            .then((res) => res.json())
            .then((res) => {
                trigger(\"atto::toast\", [
                    res.ok ? \"success\" : \"error\",
                    res.message,
                ]);
            });
    }"))

(text "{% endblock %}")
