(text "{% extends \"root.html\" %} {% block head %}")
(title
    (text "Post likes - {{ config.name }}"))

(text "{% endblock %} {% block body %} {{ macros::nav() }}")
(main
    ("class" "flex flex-col gap-2")
    (text "{% if post.replying_to -%}")
    (a
        ("href" "/post/{{ post.replying_to }}")
        ("class" "button")
        (text "{{ icon \"arrow-up\" }}")
        (span
            (text "{{ text \"communities:action.continue_thread\" }}")))
    (text "{%- endif %}")
    (div
        ("style" "display: contents;")
        (text "{% if post.context.repost and post.context.repost.reposting -%} {{ components::repost(repost=reposting, post=post, owner=owner, community=community, show_community=true, can_manage_post=can_manage_posts) }} {% else %} {{ components::post(post=post, owner=owner, question=question, community=community, show_community=true, can_manage_post=can_manage_posts, dont_show_title=true) }} {%- endif %}"))
    (div
        ("class" "pillmenu")
        (a
            ("href" "/post/{{ post.id }}#/replies")
            (text "{{ icon \"newspaper\" }}")
            (span
                (text "{{ text \"communities:label.replies\" }}")))
        (a
            ("href" "/post/{{ post.id }}/reposts")
            (text "{{ icon \"repeat-2\" }}")
            (span
                (text "{{ text \"communities:label.reposts\" }}")))
        (a
            ("href" "/post/{{ post.id }}/reposts?quotes=true")
            (text "{{ icon \"quote\" }}")
            (span
                (text "{{ text \"communities:label.quotes\" }}"))))
    (text "{% if (user and user.id == post.owner) or can_manage_posts -%}")
    (div
        ("class" "pillmenu")
        (text "{% if user and user.id == post.owner -%}")
        (a
            ("href" "/post/{{ post.id }}#/edit")
            (text "{{ icon \"pen\" }}")
            (span
                (text "{{ text \"communities:label.edit_content\" }}")))
        (text "{%- endif %}")
        (a
            ("href" "/post/{{ post.id }}/likes")
            ("class" "active")
            (text "{{ icon \"heart\" }}")
            (span
                (text "{{ text \"communities:label.likes\" }}")))
        (a
            ("href" "/post/{{ post.id }}#/configure")
            (text "{{ icon \"settings\" }}")
            (span
                (text "{{ text \"communities:action.configure\" }}"))))
    (text "{%- endif %}")
    (div
        ("class" "card-nest w-full")
        (div
            ("class" "card small flex items-center gap-2")
            (text "{{ icon \"heart\" }}")
            (span
                (text "{{ text \"communities:label.likes\" }}")))
        (div
            ("class" "card flex flex-wrap gap-4 flex-collapse")
            (text "{% for tu in list %} {% set reaction = tu[0] %} {% set user = tu[1] %}")
            (div
                ("style" "display: contents")
                ("title" "{% if reaction.is_like %}Like{% else %}Dislike{% endif %}")
                (text "{{ components::user_plate(user=user, secondary=true) }}"))
            (text "{% endfor %} {{ components::pagination(page=page, items=list|length) }}"))))

(style
    (text ".user_plate {
        width: calc(50% - var(--pad-2));
    }

    @media screen and (max-width: 900px) {
        .user_plate {
            width: 100%;
        }
    }"))

(text "{% endblock %}")
