(text "{% extends \"profile/base.html\" %} {% block content %} {% if profile.settings.enable_questions and (user or profile.settings.allow_anonymous_questions) %}")
(div
    ("style" "display: contents")
    (text "{{ components::create_question_form(receiver=profile.id, header=profile.settings.motivational_header, drawing_enabled=profile.settings.enable_drawings, allow_anonymous=profile.settings.allow_anonymous_questions) }}"))

(text "{%- endif %} {% if not tag and pinned|length != 0 -%}")
(div
    ("class" "card-nest")
    (div
        ("class" "card small flex gap-2 items-center")
        (text "{{ icon \"pin\" }}")
        (span
            (text "{{ text \"communities:label.pinned\" }}")))
    (div
        ("class" "card flex flex-col gap-4")
        (text "{% for post in pinned %} {% if post[2].read_access == \"Everybody\" -%} {% if post[0].context.repost and post[0].context.repost.reposting -%} {{ components::repost(repost=post[3], post=post[0], owner=post[1], secondary=true, community=post[2], show_community=true, can_manage_post=is_self) }} {% else %} {{ components::post(post=post[0], owner=post[1], question=post[4], secondary=true, community=post[2], can_manage_post=is_self, poll=post[5]) }} {%- endif %} {%- endif %} {% endfor %}")))

(text "{%- endif %} {{ macros::profile_nav(selected=\"posts\") }}")
(div
    ("class" "card-nest")
    (div
        ("class" "card small flex gap-2 justify-between items-center")
        (div
            ("class" "flex gap-2 items-center")
            (text "{% if not tag -%} {{ icon \"clock\" }}")
            (span
                (text "{{ text \"auth:label.recent_posts\" }}"))
            (text "{% else %} {{ icon \"tag\" }}")
            (span
                (text "{{ text \"auth:label.recent_with_tag\" }}: ")
                (b
                    (text "{{ tag }}")))
            (text "{%- endif %}"))
        (text "{% if user -%}")
        (a
            ("href" "/search?profile={{ profile.id }}")
            ("class" "button lowered small")
            (text "{{ icon \"search\" }}")
            (span
                (text "{{ text \"general:link.search\" }}")))
        (text "{%- endif %}"))
    (div
        ("class" "card w-full flex flex-col gap-2")
        ("ui_ident" "io_data_load")
        (div ("ui_ident" "io_data_marker"))))

(text "{% set paged = user and user.settings.paged_timelines %}")
(script
    (text "setTimeout(async () => {
        await trigger(\"ui::io_data_load\", [\"/_swiss_army_timeline?user_id={{ profile.id }}&tag={{ tag }}&page=\", Number.parseInt(\"{{ page }}\") - 1, \"{{ paged }}\" === \"true\"]);
        (await ns(\"ui\")).IO_DATA_DISABLE_RELOAD = true;
        console.log(\"created profile timeline\");
    }, 1000);"))

(text "{% endblock %}")
