pub mod common;

use std::collections::HashMap;
use tetratto_l10n::{read_langs, LangFile};
use oiseau::postgres::{DataManager as OiseauManager, Result};
use crate::config::Config;

#[derive(Clone)]
pub struct DataManager(pub OiseauManager<Config>, pub HashMap<String, LangFile>);

impl DataManager {
    /// Create a new [`DataManager`].
    pub async fn new(config: Config) -> Result<Self> {
        Ok(Self(OiseauManager::new(config).await?, read_langs()))
    }
}
