// @ts-nocheck
// APP_API_KEY=... deno run --allow-net --allow-import --allow-env -r app_sdk_test.js
const deno = Deno;
const sdk = (await import("http://localhost:4118/js/app_sdk.js")).default({
    host: "http://localhost:4118",
    api_key: deno.env.get("APP_API_KEY"),
});

// check data used
console.log("data used:", (await sdk.app()).data_used);

// record insert
await sdk.insert("deno_test", "Hello, Deno!");
console.log("record created");
console.log("data used:", (await sdk.app()).data_used);

// testing record query then delete
let record = (
    await sdk.query({
        query: { KeyIs: "deno_test" },
        mode: { One: 0 },
    })
).One;

console.log(record);

await sdk.update("deno_test", "Hello, Deno! 1");
console.log("record updated");
console.log("data used:", (await sdk.app()).data_used);

record = (
    await sdk.query({
        query: { KeyIs: "deno_test" },
        mode: { One: 0 },
    })
).One;

console.log(record);

await sdk.remove(record.id);
console.log("record deleted");
console.log("data used:", (await sdk.app()).data_used);
